//+------------------------------------------------------------------+
//|                                               high-frequency.mq4 |
//|                                                    |
//|                                           http://vk.com/senchakv |
//+------------------------------------------------------------------+
#property copyright " "
#property link      "http://vk.com/senchakv"
#property version   "1.00"
#property strict

extern string _lot=" ";
extern double lot=0.01;

extern string _profit="   $";
extern double profit=0.2;

extern string _N="  ";
extern int N=15;

extern string _K="   ";
extern int K=4;

extern string _min_range="   ";
extern double min_range=0.00003;

extern string _range_stop="     ";
extern double range_stop=0.00066;

extern string _magic="   ";
extern int magic=1;

// 
datetime time_end;

double tick_avg=0;
double range_avg=0;

int kol_tick=0;

double range_start=0;
double range_end=0;

int mass_tick[];
double mass_range[];

int OnInit()
  {
//---
   ArrayResize(mass_tick,K);
   ArrayResize(mass_range,K);
   
   for (int i=0;i<K;i++)
   {
     mass_tick[i]=0;
     mass_range[i]=0;
   }
   
   range_start=Bid;
   
   time_end=TimeCurrent()+N;
//---
   return(INIT_SUCCEEDED);
  }

void Opentrade(double range_s,double range_e)
{   
  int Ticket;
  if (range_e>range_s)
  {close_reserve();
     //Ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,3,0,0,"    :"+TimeToStr(TimeCurrent(),TIME_MINUTES),magic,0,Blue);
     //Ticket=OrderSend(Symbol(),OP_BUYSTOP,lot,Ask+range_stop,3,0,0,"  :"+TimeToStr(TimeCurrent(),TIME_MINUTES),magic,0,Blue);
     Ticket=OrderSend(Symbol(),OP_SELLLIMIT,lot,Bid+range_stop,3,0,0,"  :"+TimeToStr(TimeCurrent(),TIME_MINUTES),magic,0,Red);
  } else
  if (range_e<range_s)
  {close_reserve();
     //Ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,3,0,0,"    :"+TimeToStr(TimeCurrent(),TIME_MINUTES),magic,0,Red);
     //Ticket=OrderSend(Symbol(),OP_SELLSTOP,lot,Bid-range_stop,3,0,0,"  :"+TimeToStr(TimeCurrent(),TIME_MINUTES),magic,0,Red);
     Ticket=OrderSend(Symbol(),OP_BUYLIMIT,lot,Ask-range_stop,3,0,0,"  :"+TimeToStr(TimeCurrent(),TIME_MINUTES),magic,0,Blue);
  }
}
void CloseAll()
{  
  bool b;
  int total = OrdersTotal() - 1;   
  for (int i = total; i >= 0; i--) 
  {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
        if (OrderMagicNumber() == magic)
        {        
            if (OrderType() == OP_SELL || OrderType() == OP_BUY)
            b=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 20, Yellow); 
        }    
    }    
  } 
}
void close_reserve()
{ 
  bool b;
  int total = OrdersTotal() - 1;   
  for (int i = total; i >= 0; i--) 
  {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
        if (OrderMagicNumber() == magic)
        {
            if (OrderType() == OP_BUYLIMIT) b=OrderDelete(OrderTicket());
            if (OrderType() == OP_BUYSTOP)  b=OrderDelete(OrderTicket());
            if (OrderType() == OP_SELLLIMIT)b=OrderDelete(OrderTicket());
            if (OrderType() == OP_SELLSTOP) b=OrderDelete(OrderTicket());           
        }    
    }    
  }
}
double value_profit()
{
   double ld_0 = 0;
   int l_ord_total_8 = OrdersTotal();
   if (l_ord_total_8 > 0) 
   {
      for (int l_pos_12 = l_ord_total_8 - 1; l_pos_12 >= 0; l_pos_12--) 
      {
         if (OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES))
         {
          if (OrderMagicNumber() == magic)
          ld_0 += OrderProfit() + OrderSwap()+OrderCommission();
         } 
      }
   }
  return(ld_0);
}
void OnTick()
  {
   if (OrdersTotal()!=0)
   {
     if (value_profit()>=profit) {CloseAll();close_reserve();}
   }
//---
   if (TimeCurrent()<time_end)
   {
     kol_tick++;
   } else
   {
     time_end=TimeCurrent()+N;
     
     range_end=Bid;
     
     for (int i=0; i<K-1; i++)
     {
       mass_tick[i]=mass_tick[i+1];
       mass_range[i]=mass_range[i+1];
     }
     mass_tick[K-1]=kol_tick;
     mass_range[K-1]=MathAbs(range_start-range_end);
     
     if (mass_tick[0]!=0)
     {
       tick_avg=0;
       range_avg=0;
       for (int i=0;i<K;i++)
       {
         tick_avg+=mass_tick[i];
         range_avg+=mass_range[i];
       }
       
       tick_avg=tick_avg/K;
       range_avg=range_avg/K;
       
       if (kol_tick>tick_avg && MathAbs(range_start-range_end)>range_avg && MathAbs(range_start-range_end)>min_range)
       {
         //  
         Opentrade(range_start,range_end);
       }
     }

     kol_tick=0;
     range_start=Bid;
   }
  }
//+------------------------------------------------------------------+
